<ui:composition xmlns:a4j="http://richfaces.org/a4j" xmlns:f="http://java.sun.com/jsf/core"
                xmlns:g="http://www.ihe.net/gazelle" xmlns:gdk="http://www.ihe.net/gazellecdk"
                xmlns:h="http://java.sun.com/jsf/html" xmlns:rich="http://richfaces.org/rich"
                xmlns:s="http://jboss.org/schema/seam/taglib" xmlns:ui="http://java.sun.com/jsf/facelets"
                xmlns="http://www.w3.org/1999/xhtml">
    <a4j:region>
        <div class="form-horizontal">
            <s:decorate template="/layout/form/_form_field_horizontal_4-8.xhtml"
                        rendered="#{currentRequest.selectedNode == null}">
                <ui:define name="label">#{messages['net.ihe.gazelle.hpd.OrganizationalUnitToQueryOn']}
                </ui:define>
                <ui:param name="id" value="nodeInput"/>
                <h:selectOneMenu value="#{currentRequest.selectedNode}" id="nodeInput"
                                 styleClass="form-control">
                    <s:selectItems value="#{providerInformationConsumer.getAvailableNodes()}" var="n"
                                   label="#{n.name}"
                                   noSelectionLabel="#{messages['net.ihe.gazelle.hpd.PleaseSelect']}"/>
                    <a4j:ajax event="change" render="requestConfPanel" execute="@this"
                              listener="#{providerInformationConsumer.onNodeSelected(currentRequest)}"/>
                </h:selectOneMenu>
            </s:decorate>
        </div>
        <s:div rendered="#{currentRequest.selectedNode != null}">
            <dl class="dl-horizontal">
                <s:decorate template="/layout/display/_data_list_item.xhtml">
                    <ui:define name="label">#{messages['net.ihe.gazelle.hpd.OrganizationalUnitToQueryOn']}</ui:define>
                    <h:outputText value="#{currentRequest.selectedNode.name}"/>
                </s:decorate>
            </dl>
        </s:div>
    </a4j:region>
    <s:div id="requestOptions"
           rendered="#{currentRequest.selectedNode != null}">
        <ui:decorate template="/layout/panels/_panel_collapse.xhtml">
            <ui:param name="panel_id" value="searchOptions#{currentRequest.index}"/>
            <ui:param name="openByDefault" value="true"/>
            <ui:define name="panel_title">#{messages['net.ihe.gazelle.hpd.SearchRequestOptions']}</ui:define>
            <div class="form-horizontal">
                <s:decorate template="/layout/form/_form_field_horizontal_3-9.xhtml">
                    <ui:param name="id" value="dnToSearchOn"/>
                    <ui:define name="label">#{messages['net.ihe.gazelle.hpd.DN']}</ui:define>
                    <h:inputText value="#{currentRequest.request.dn}" id="dnToSearchOn"
                                 styleClass="form-control" required="true"
                                 requiredMessage="DN attribute is required"/>
                </s:decorate>
                <s:decorate template="/layout/form/_form_field_horizontal_3-9.xhtml" id="scopeDecorate">
                    <ui:param name="id" value="scopeIn"/>
                    <ui:define name="label">#{messages['net.ihe.gazelle.hpd.Scope']}</ui:define>
                    <h:selectOneMenu value="#{currentRequest.request.scope}" id="scopeIn"
                                     styleClass="form-control"
                                     required="true" requiredMessage="You must select a scope">
                        <s:selectItems value="#{providerInformationConsumer.scopeValues}" var="enum"
                                       label="#{enum.value()}"
                                       noSelectionLabel="#{messages['net.ihe.gazelle.hpd.PleaseSelect']}"/>
                        <a4j:ajax event="change" render="scopeDecorate"/>
                    </h:selectOneMenu>
                </s:decorate>
                <s:decorate template="/layout/form/_form_field_horizontal_3-9.xhtml" id="derefAliasesDecorate">
                    <ui:param name="id" value="derefIn"/>
                    <ui:define name="label">#{messages['net.ihe.gazelle.hpd.DerefAliases']}</ui:define>
                    <h:selectOneMenu value="#{currentRequest.request.derefAliases}" id="derefIn"
                                     styleClass="form-control"
                                     required="true" requiredMessage="You must select a value for derefAliases">
                        <s:selectItems value="#{providerInformationConsumer.derefAliasesValues}" var="enum"
                                       label="#{enum.value()}"
                                       noSelectionLabel="#{messages['net.ihe.gazelle.hpd.PleaseSelect']}"/>
                        <a4j:ajax event="change" render="derefAliasesDecorate"/>
                    </h:selectOneMenu>
                </s:decorate>
                <s:decorate template="/layout/form/_form_field_horizontal_3-9.xhtml" id="sizeLimitDecorate">
                    <ui:param name="id" value="sizeIn"/>
                    <ui:define name="label">#{messages['net.ihe.gazelle.hpd.SizeLimit']}</ui:define>
                    <rich:inputNumberSpinner id="sizeIn"
                                             value="#{currentRequest.request.sizeLimit}"
                                             maxValue="#{providerInformationConsumer.maxValue}"/>
                </s:decorate>
                <s:decorate template="/layout/form/_form_field_horizontal_3-9.xhtml" id="timeLimitDecorate">
                    <ui:param name="id" value="timeIn"/>
                    <ui:define name="label">#{messages['net.ihe.gazelle.hpd.TimeLimit']}</ui:define>
                    <rich:inputNumberSpinner id="timeIn"
                                             value="#{currentRequest.request.timeLimit}"
                                             maxValue="#{providerInformationConsumer.maxValue}"/>
                </s:decorate>
                <s:decorate template="/layout/form/_form_checkbox_horizontal_3-9.xhtml" id="typesOnlyDecorate">
                    <h:selectBooleanCheckbox id="typesIn"
                                             value="#{currentRequest.request.typesOnly}"/>
                    #{messages['net.ihe.gazelle.hpd.TypesOnly']}
                </s:decorate>
            </div>
        </ui:decorate>
        <ui:decorate template="/layout/panels/_panel_collapse.xhtml">
            <ui:param name="panel_id" value="filterPanel#{currentRequest.index}"/>
            <ui:param name="openByDefault" value="false"/>
            <ui:define name="panel_title">#{messages['net.ihe.gazelle.hpd.Filter']}</ui:define>
            <s:div styleClass="row" id="buttons">
                <s:div styleClass="btn-group" rendered="#{currentRequest.searchFilter == null}">
                    <button type="button" class="btn gzl-btn-blue dropdown-toggle" data-toggle="dropdown"
                            aria-haspopup="true" aria-expanded="false">Create filter<span class="caret"/>
                    </button>
                    <ui:include src="/prov_info_cons/_listExpressionButtons.xhtml">
                        <ui:param name="currentRequest" value="#{currentRequest}"/>
                        <ui:param name="parent" value="#{null}"/>
                    </ui:include>
                </s:div>
            </s:div>
            <br/><br/>
            <s:div styleClass="col-lg-offset-1 col-lg-10" id="filterConfigPanel">
                <f:subview id="mainFilter" rendered="#{currentRequest.searchFilter != null}">
                    <ui:include src="/prov_info_cons/filter.xhtml">
                        <ui:param name="currentRequest"
                                  value="#{currentRequest}"/>

                    </ui:include>
                </f:subview>
            </s:div>
        </ui:decorate>
        <ui:decorate template="/layout/panels/_panel_collapse.xhtml">
            <ui:param name="panel_id" value="attributesPanel#{currentRequest.index}"/>
            <ui:param name="openByDefault" value="false"/>
            <ui:define name="panel_title">#{messages['net.ihe.gazelle.hpd.ExpectedAttributesSelection']}</ui:define>
            <h:outputText
                    value="#{messages['net.ihe.gazelle.hpd.SelectTheAttributesYouWantTheDirectoryToReturn']}"/>
            <div class="row">
                <div class="col-md-5">
                    <rich:autocomplete mode="client"
                                       autocompleteList="#{currentReq.getAvailableAttributeTypes()}"
                                       value="#{providerInformationConsumer.attributeName}" minChars="1"
                                       autofill="false"
                                       selectFirst="false"
                                       required="false" id="attrCombo"
                                       layout="list"/>
                </div>
                <div class="col-md-2">
                    <a4j:commandButton value="#{messages['net.ihe.gazelle.hpd.AddToList']}" styleClass="gzl-btn-blue"
                                       actionListener="#{providerInformationConsumer.addAttributeToRequest(currentRequest)}"
                                       render="attrCombo,attrList"/>
                </div>
            </div>
            <br/>
            <s:div styleClass="row" id="attrList">
                <a4j:repeat value="#{currentRequest.getRequestedAttributes()}" var="attr">
                    <a4j:commandButton actionListener="#{currentRequest.changeAttributeState(attr)}"
                                       value="#{attr}" style="margin-bottom: 15px;"
                                       styleClass="col-md-2 #{currentRequest.getClassForAttribute(attr)}"
                                       render="attrList"/>
                </a4j:repeat>
            </s:div>
        </ui:decorate>
    </s:div>
    <!--@formatter:off-->
    <script>
        disable_input_spinner_mouse_wheel('#{rich:clientId('timeIn')}');
        disable_input_spinner_mouse_wheel('#{rich:clientId('sizeIn')}');
    </script>
    <!--@formatter:on-->
</ui:composition>